;;; Sierra Script 1.0 - (do not remove this comment)
(script# FEATURE)
(include game.sh)
(use Main)
(use Intrface)
(use System)


(class Feature of Object
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 90
		closeRangeDist 50
		longRangeDist 100
		shiftClick -32767
		contClick 7
		actions 0
		control 0
		verbChecks1 -17483
		verbChecks2 -17477
		verbChecks3 -17477
	)
	
	(procedure (DefaultDoVerb theVerb)
		(switch theVerb
			(verbLook
				(Printf FEATURE 0 description description)
			)
			(verbOpen (Printf FEATURE 1 description))
			(verbClose (Printf FEATURE 2 description))
			(verbSmell (Printf FEATURE 3 description))
			(verbMove (Printf FEATURE 4 description))
			(verbEat (Printf FEATURE 5 description))
			(verbGet (Printf FEATURE 6 description))
			(verbClimb (Printf FEATURE 7 description))
			(verbTalk (Printf FEATURE 8 description))
		)
	)
	
	
	(method (init)
		(features add: self)
		(if (not description) (= description name))
	)
	
	(method (dispose)
		(features delete: self)
		(super dispose:)
	)
	
	(method (handleEvent event &tmp temp0 temp1)
		(if (event claimed?) (return TRUE))
		(switch (event type?)
			(saidEvent
				(cond 
					((not (Said noun)))
					((not (= temp1 (event message?))) (event claimed: FALSE))
					((self passedChecks: temp1) (self doVerb: temp1))
					((IsObject actions) (actions handleEvent: event self))
				)
			)
			(mouseDown
				(cond 
					((not (= temp0 (event modifiers?))))
					((not (self onMe: event)))
					((& temp0 $0003)
						(if
							(or
								(& shiftClick $8000)
								(self passedChecks: shiftClick)
							)
							(self doVerb: (& $7fff shiftClick))
						)
						(event claimed: TRUE)
					)
					((& temp0 $0004)
						(if
						(or (& contClick $8000) (self passedChecks: contClick))
							(self doVerb: (& $7fff contClick))
						)
						(event claimed: TRUE)
					)
				)
			)
		)
		(return (event claimed?))
	)
	
	(method (setChecks param1 param2 &tmp temp0 temp1)
		(= temp0
			(<< param2 (= temp1 (* 4 (mod (- param1 1) 4))))
		)
		(cond 
			((<= param1 4)
				(= verbChecks1 (& verbChecks1 (~ (<< $000f temp1))))
				(= verbChecks1 (| verbChecks1 temp0))
			)
			((<= param1 8)
				(= verbChecks2 (& verbChecks2 (~ (<< $000f temp1))))
				(= verbChecks2 (| verbChecks2 temp0))
			)
			(else
				(= verbChecks3 (& verbChecks3 (~ (<< $000f temp1))))
				(= verbChecks3 (| verbChecks3 temp0))
			)
		)
	)
	
	(method (doVerb theVerb)
		(DefaultDoVerb theVerb description)
	)
	
	(method (notInFar)
		(Printf FEATURE 9 description)
	)
	
	(method (notInNear)
		(Printf FEATURE 10 description)
	)
	
	(method (notFacing &tmp temp0)
		(Printf FEATURE 11 description)
	)
	
	(method (facingMe param1 &tmp temp0 temp1)
		(= temp0 (if argc param1 else ego))
		(if
			(>
				(= temp1
					(Abs
						(-
							(GetAngle (temp0 x?) (temp0 y?) x y)
							(temp0 heading?)
						)
					)
				)
				180
			)
			(= temp1 (- 360 temp1))
		)
		(return
			(if (<= temp1 sightAngle)
				(return 1)
			else
				(self notFacing:)
				(return 0)
			)
		)
	)
	
	(method (nearCheck param1 &tmp temp0)
		(= temp0 (if argc param1 else ego))
		(return
			(if
				(<=
					(GetDistance (temp0 x?) (temp0 y?) x y)
					closeRangeDist
				)
				(return 1)
			else
				(self notInNear:)
				(return 0)
			)
		)
	)
	
	(method (farCheck param1 &tmp temp0)
		(= temp0 (if argc param1 else ego))
		(return
			(if
				(<=
					(GetDistance (temp0 x?) (temp0 y?) x y)
					longRangeDist
				)
				(return 1)
			else
				(self notInFar:)
				(return 0)
			)
		)
	)
	
	(method (isNotHidden)
		(return TRUE)
	)
	
	(method (onMe param1 param2 &tmp temp0 temp1)
		(if (IsObject param1)
			(= temp0 (param1 x?))
			(= temp1 (param1 y?))
		else
			(= temp0 param1)
			(= temp1 param2)
		)
		(return
			(if
				(and
					(<= nsLeft temp0)
					(<= temp0 nsRight)
					(<= nsTop temp1)
					(<= temp1 nsBottom)
				)
				(if control
					(& control (OnControl 4 temp0 temp1))
				else
					1
				)
			else
				0
			)
		)
	)
	
	(method (passedChecks param1 &tmp temp0)
		(if
			(and
				(or
					(not
						(&
							(= temp0
								(&
									(>>
										(if (<= param1 4) verbChecks1 else verbChecks2)
										(* 4 (mod (- param1 1) 4))
									)
									$000f
								)
							)
							$0008
						)
					)
					(self isNotHidden:)
				)
				(or (not (& temp0 $0004)) (self farCheck:))
				(or (not (& temp0 $0002)) (self nearCheck:))
			)
			(if (not (& temp0 $0001)) else (self facingMe:))
		)
	)
)
