;;; Sierra Script 1.0 - (do not remove this comment)
;
; * SCI Game Header
; *************************************************************************
; * Put all the defines specific to your game in here

(include system.sh) (include sci2.sh)

;Inventory items
(enum
	iDagger			;0
	iChest			;1
	iCarrot			;2
	iKey			;3
	iNote			;4
	iMagicRing		;5
	iFourLeafClover	;6
	iCeramicBowl	;7
	iWaterBucket	;8
	iPebbles		;9
	iSlingshot		;10
	iPouch			;11
	iSceptre		;12
	iCheese			;13
	iMagicMirror	;14
	iGoldEgg		;15
	iMagicShield	;16
	iFiddle			;17
	iWalnut			;18
	iMushroom		;19
	iBeans			;20
)

;Who's carrying Graham through the sky
(enum 1
	carrierCONDOR 	;1
	carrierWITCH	;2
)

;Regions
(enum 600
	GOAT		;600
	TROLL		;601
	MENACE		;602
	WATER		;603
	GARDEN		;604
	MOAT		;605
	BEANS		;606
	STALK		;607
	RIVER		;608
	CLIMB		;609
	CLOUDS		;610
	BIRD		;611
	WATER_42	;612 ;room 42 has both safe and deadly water, so a special region is needed for it
	FALLING		;613
)
(define HALO 616)

;Menaces
(define SORCERER 800)
(define OGRE 803)
(define DWARF 804)

;Event flags
(enum
	GRAHAM_MINI					;0	;for Graham's small views, which are used in Cloudland
	GRAHAM_INVISIBLE			;1
	GOAT_FOLLOWING_GRAHAM		;2
	UNUSED_3					;3
	TROLL_PAID					;4
	TROLL_DROWNED				;5
	GNOME_ASKS_QUESTION			;6
	VISITED_LEPRECHAUN_THRONE	;7
	VISITED_WOODCUTTER_HOUSE	;8
	BUCKET_HAS_WATER			;9
	EATEN_CARROT				;10
	ATTACKED_ELF				;11
	WITCH_GRABBED_GRAHAM		;12
	TROLL_BLOCKS_BRIDGE			;13
	SCEPTRE_ON_THRONE			;14
	WITCH_CUPBOARD_OPEN			;15
	WITCH_IS_HOME				;16
	WEARING_RING				;17
	GRAHAM_IN_BUCKET			;18
	CLIMBING_WELL_ROPE			;19
	WELL_ROPE_LOWERED			;20
	WATER_BUCKET_LOWERED		;21
	MET_FAIRY_GODMOTHER			;22
	GOAT_GATE_OPEN				;23
	OBTAINED_BUCKET_FROM_WELL	;24
	CUT_WELL_ROPE				;25
	OPENED_CHEST				;26
	MET_GNOME					;27
	MUGGED_IN_CAVE				;28
	FLAG_29						;29
	FLAG_30						;30	;related in some way to the dwarf appearing in the mountain cave
	DWARF_IN_CAVE				;31
	GAVE_SOMETHING_TO_RAT		;32
	LEPRECHAUNS_GONE			;33
	EATEN_STEW					;34
	EATEN_BEANS					;35
	BEFRIENDED_GOAT				;36
	GNOME_ATTENTION				;37
	GIANT_ASLEEP				;38
	MOUNTAIN_DOOR_OPEN			;39
	IN_CUTSCENE 				;40 ;when not playing the game proper
	UNUSED_41					;41
	UNUSED_42					;42
	PUSHING_WITCH				;43
	CLIMBING_HILL				;44
	UNUSED_45					;45
	FALLING_FROM_TREE			;46
	BUCKET_FLOATS_IN_WELL		;47
	GRAHAM_CLIMBING				;48
	LOOKED_AT_GARDEN			;49
	LOOKED_AT_BORDER_IN_GARDEN	;50
	GODMOTHER_SPELL_EXPIRED		;51
	UNUSED_52					;52
	UNUSED_53					;53
	UNUSED_54					;54
	UNUSED_55					;55
	UNUSED_56					;56
	UNUSED_57					;57
	UNUSED_58					;58
	UNUSED_59					;59
	SAW_POUCH_IN_STUMP			;60
	OBTAINED_POUCH				;61
	OPENED_POUCH				;62
	FILLED_WATER_BUCKET			;63
	PICKED_CARROT				;64
	OBTAINED_MAGIC_RING			;65
	OBTAINED_WALNUT				;66
	OPENED_WALNUT				;67
	UNLOCKED_MOUNTAIN_DOOR		;68
	OBTAINED_MUSHROOM			;69
	OBTAINED_CLOVER				;70
	OBTAINED_SHIELD				;71
	OBTAINED_SCEPTRE			;72
	CLIMBED_DOWN_WELL			;73
	KILLED_WITCH				;74
	DISCOVER_CHEESE				;75
	OBTAINED_CHEESE				;76
	OBTAINED_NOTE				;77
	READ_NOTE					;78
	ATE_WITCH_HOUSE				;79
	OFFERED_CARROT_TO_GOAT		;80
	OBTAINED_BOWL				;81
	DOUSED_DRAGON				;82
	KILLED_DRAGON				;83
	OBTAINED_MIRROR				;84
	OBTAINED_SLINGSHOT			;85
	KILLED_GIANT				;86
	OBTAINED_CHEST				;87
	EXHAUSTED_GIANT				;88
	MOVED_ROCK					;89
	TOOK_DAGGER					;90
	TOOK_PEBBLES				;91
	OBTAINED_KEY				;92
	READ_BOWL					;93
	OBTAINED_GOLD_EGG			;94
	OBTAINED_WATER_BUCKET		;95
	CLIMBED_DOWN_WELL_2			;96 ;set at same time as flag 73. Why the redundant flags?
	DIVE_UNDERWATER				;97
	ENTERED_DRAGON_DEN			;98
	ENTERED_ROCK_CAVE			;99
	GOT_RIDE_FROM_BIRD			;100
	CLIMBED_TREE				;101
	GAVE_RAT_CHEESE				;102
	LEPRECHAUN_DANCE			;103
	EATEN_MUSHROOM				;104
	EXIT_LEPRECHAUN_CAVE		;105
	GOAT_KILLED_TROLL			;106
	UNUSED_107					;107
	OBTAINED_BEANS				;108
	PLANTED_BEANSTALK			;109
	CLIMBED_TO_CLOUDLAND		;110
	ENTER_CASTLE_END			;111
	BOWL_HAS_STEW				;112
	GAVE_STEW_TO_WOODCUTTER		;113
	OBTAINED_FIDDLE 			;114
)