;;; Sierra Script 1.0 - (do not remove this comment)
(script# 67)
(include game.sh)
(use Main)
(use Intrface)
(use NewFeature)
(use LoadMany)
(use Motion)
(use Game)
(use User)
(use System)

(public
	rm67 0
)

(instance rm67 of Room
	(properties
		picture 67
		horizon 35
		east 68
		west 66
	)
	
	(method (init)
		(LoadMany VIEW 4 7 56 66 136)
		(Load SCRIPT FALLING)
		(Load SOUND 17)
		(if (ego has: iMagicRing) (LoadMany VIEW 38 39))
		(self style:
		(switch prevRoomNum
			(west 3)
			(else  2)
		))
		(super init:)
		(switch prevRoomNum
			(west
				(ego posn: 17 186 loop: 0)
			)
			(else  (ego posn: 299 56))
		)
		(Bset GRAHAM_MINI)
		(ego init:)
		(NormalEgo)
		(walkway1 init:)
	)
	
	(method (doit &tmp temp0)
		(cond 
			(script (script doit:))
			((== (ego priority?) 1) (ego setPri: 2))
			((== (ego onControl: origin) 8) (self setScript: (ScriptID 613 0)))
			((== (ego onControl: origin) 16) (self setScript: (ScriptID 613 1)))
			((== (ego onControl: origin) 256) (self setScript: (ScriptID 613 2)))
			((== (ego onControl: origin) 2) (self setScript: (ScriptID 613 3)))
			((== (ego onControl: origin) 4) (self setScript: (ScriptID 613 4)))
			((== (ego onControl: origin) 1024) (self setScript: (ScriptID 613 5)))
			((== (ego onControl: origin) 16384) (self setScript: (ScriptID 613 6)))
			((ego inRect: 0 50 15 61) (self setScript: goingLow))
			((ego inRect: 0 71 15 83) (self setScript: goingHigh))
			((== (ego onControl: origin) 8192) (self newRoom: 68))
			((== (ego onControl: origin) 4096) (Bclr GRAHAM_MINI) (Bclr DWARF_IN_CAVE) (self newRoom: 66))
		)
	)
	
	(method (handleEvent event)
		(cond 
			((event claimed?) (return))
			((super handleEvent: event) (return))
			(
				(and
					(== (event type?) mouseDown)
					(& (event modifiers?) shiftDown)
					(& (OnControl 4 (event x?) (event y?)) $0800)
					(User canInput:)
				)
				(event claimed: TRUE)
				(Print 67 0)
			)
			((Said 'look,check>')
				(cond 
					((Said '[<at,around][/room,cave]') (Print 67 1))
					((Said '/catwalk,path') (Print 67 0))
				)
			)
		)
	)
)

(instance goingLow of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(NormalEgo)
				(ego illegalBits: 0 loop: 0 cel: 0 posn: 17 78)
				(= seconds 2)
			)
			(1
				(ego setStep: 2 2 setMotion: MoveTo 30 78 self)
			)
			(2
				(ego illegalBits: cWHITE)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance goingHigh of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(NormalEgo)
				(ego illegalBits: 0 loop: 1 cel: 0 posn: 17 56)
				(= seconds 2)
			)
			(1
				(ego setStep: 2 2 setMotion: MoveTo 31 56 self)
			)
			(2
				(ego illegalBits: cWHITE)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance walkway1 of NewFeature
	(properties
		x 164
		y 56
		noun 'catwalk<overhead'
		nsTop 50
		nsLeft 27
		nsBottom 63
		nsRight 301
		description {overhead walkway}
		sightAngle 360
		getableDist 320
		seeableDist 320
		shiftClick 369
		contClick 371
		lookStr {There is a wooden walkway suspended from the cave's ceiling.}
	)
)
