;;; Sierra Script 1.0 - (do not remove this comment)
(script# 69)
(include game.sh)
(use Main)
(use Intrface)
(use NewFeature)
(use LoadMany)
(use Motion)
(use Game)
(use User)
(use Actor)
(use System)

(public
	rm69 0
)

(local
	local0
	local1
	local2
	local3
)
(procedure (DwarfSteals item points)
	(return
		(if (ego has: item)
			(ego put: item)
			(theGame changeScore: (- 0 points))
			(Print 69 7)
			(return TRUE)
		else
			(return FALSE)
		)
	)
)

(procedure (SmallInvisibleGraham)
	(if (Btst GRAHAM_INVISIBLE) (ego view: 42) else (ego view: 56))
)

(instance rm69 of Room
	(properties
		picture 69
		horizon 20
		south 68
		west 59
	)
	
	(method (init)
		(LoadMany VIEW 4 7 56 66 136)
		(if (ego has: iMagicRing) (LoadMany VIEW 38 39))
		(Load SCRIPT 613)
		(Load SOUND 17)
		(self style:
		(switch prevRoomNum
			(west WIPERIGHT)
			(south WIPEUP)
		))
		(super init:)
		(switch prevRoomNum
			(south
				(ego posn: 189 187 setLoop: 0 cel: 0)
			)
			(west (ego loop: 0 posn: 1 39))
			(else  (ego posn: 150 130))
		)
		(Bset GRAHAM_MINI)
		(ego init:)
		(NormalEgo)
		(if (not (Btst MUGGED_IN_CAVE))
			(if (not (Btst DWARF_IN_CAVE))
				(cond 
					((< (Random 1 100) 51) (Bclr 29) (Bclr 30))
					((< (Random 1 100) 51) (Bset 30) (Bclr 29))
					(else (Bset 29) (Bclr 30))
				)
				(Bset DWARF_IN_CAVE)
			)
			(dwarf view: 136 setCycle: Walk init: hide:)
		)
		(cave init:)
	)
	
	(method (doit &tmp temp0)
		(if
			(and
				(< (ego y?) 96)
				(>= (ego x?) 219)
				(not (Btst GRAHAM_INVISIBLE))
			)
			(= local2 1)
		)
		(if
			(and
				(>= (ego y?) 96)
				(>= (ego x?) 136)
				(not (Btst GRAHAM_INVISIBLE))
			)
			(= local3 1)
		)
		(cond 
			(script (script doit:))
			(
				(and
					(Btst 30)
					(not (Btst MUGGED_IN_CAVE))
					(== (ego onControl: origin) 1024)
					(not (Btst GRAHAM_INVISIBLE))
					(>= (ego y?) 95)
					local3
				)
				(self setScript: takeWhatYouCan)
			)
			(
				(and
					(Btst 30)
					(not (Btst MUGGED_IN_CAVE))
					(== (ego onControl: origin) 1024)
					(not (Btst GRAHAM_INVISIBLE))
					(< (ego y?) 96)
					local2
				)
				(self setScript: takeWhatYouCan)
			)
			((== (ego onControl: origin) 8) (self setScript: (ScriptID 613 0)))
			((== (ego onControl: origin) 16) (self setScript: (ScriptID 613 1)))
			((== (ego onControl: origin) 256) (self setScript: (ScriptID 613 2)))
			((== (ego onControl: origin) 2) (self setScript: (ScriptID 613 3)))
			((== (ego onControl: origin) 4) (self setScript: (ScriptID 613 4)))
			((== (ego onControl: origin) 16384) (self setScript: (ScriptID 613 6)))
			((== (ego onControl: origin) 64) (self setScript: fadeOut))
			((== (ego onControl: origin) 32) (self setScript: fadeIn))
			(
				(= temp0
					(switch ((User alterEgo?) edgeHit?)
						(NORTH north)
						(EAST east)
						(SOUTH south)
						(WEST west)
					)
				)
				(if (== (ego edgeHit?) WEST) (Bclr DWARF_IN_CAVE))
				(self newRoom: temp0)
			)
		)
	)
	
	(method (handleEvent event)
		(cond 
			((event claimed?) (return))
			((super handleEvent: event) (return))
			(
				(and
					(== (event type?) mouseDown)
					(& (event modifiers?) shiftDown)
					(& (OnControl 4 (event x?) (event y?)) $0c00)
					(User canInput:)
				)
				(event claimed: TRUE)
				(Print 69 0)
			)
			((Said 'look,check>')
				(cond 
					((Said '[<at,around][/room,cave]') (Print 69 1))
					((Said '/catwalk,path') (Print 69 0))
					((Said '/dwarf,man') (Print 69 2))
				)
			)
		)
	)
)

(instance fadeOut of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(= local2 0)
				(= local3 0)
				(SmallInvisibleGraham)
				(ego
					illegalBits: 0
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(ego posn: 153 57)
				(= seconds 4)
			)
			(2
				(NormalEgo)
				(ego
					loop: 0
					cel: 0
					setPri: 1
					setMotion: MoveTo 174 56 self
				)
			)
			(3
				(ego setPri: -1)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance fadeIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(= local2 0)
				(= local3 0)
				(ego setPri: 1 setMotion: MoveTo 155 57 self)
			)
			(1
				(SmallInvisibleGraham)
				(ego
					illegalBits: 0
					setLoop: 0
					cel: 0
					setCycle: 0
					setMotion: MoveTo 90 109 self
				)
			)
			(2
				(ego cycleSpeed: 1 setCycle: EndLoop self)
			)
			(3
				(NormalEgo)
				(ego loop: 2 cel: 0 setMotion: MoveTo 90 114 self)
			)
			(4
				(ego setPri: -1)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance takeWhatYouCan of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				((ScriptID 0 21) number: 93 loop: 1 init: play:)
				(Print 69 3)
				(dwarf show:)
				(if (= local1 (< (ego y?) 95))
					(dwarf posn: 156 61 setMotion: MoveTo 201 52 self)
				else
					(dwarf posn: 94 106 setMotion: MoveTo 91 113 self)
				)
			)
			(1
				(if local1
					(self cue:)
				else
					(dwarf setMotion: MoveTo 107 125 self)
				)
			)
			(2
				(cond 
					(haloTimer (Print 69 4))
					((Btst GRAHAM_INVISIBLE) (Print 69 5))
					((DwarfSteals iMagicShield 8))
					((DwarfSteals iMagicMirror 8))
					((DwarfSteals iChest 8))
					((and (Btst OPENED_POUCH) (DwarfSteals iPouch 6)))
					((DwarfSteals iPouch 3))
					((and (Btst OPENED_WALNUT) (DwarfSteals iWalnut 6)))
					((DwarfSteals iGoldEgg 6))
					((DwarfSteals iSceptre 6))
					(else (Print 69 6))
				)
				(= cycles 10)
			)
			(3
				(dwarf loop: 3 cel: 0)
				(= cycles 2)
			)
			(4 (dwarf setCycle: EndLoop self))
			(5
				((ScriptID 0 21) fade:)
				(Bset MUGGED_IN_CAVE)
				(dwarf dispose:)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance dwarf of Actor
	(properties)
)

(instance cave of NewFeature
	(properties
		x 94
		y 89
		noun 'cave'
		nsTop 68
		nsLeft 71
		nsBottom 111
		nsRight 117
		description {cave}
		sightAngle 360
		getableDist 320
		seeableDist 320
		shiftClick 369
		contClick 371
		lookStr {You can't see much of anything in the dark cave.}
	)
)
